#north alingment with +Y
#Version 2
#only works in SU8
#by Juantxo


require 'sketchup'
def northrotationbug (northcase)

model=Sketchup.active_model
entities=model.entities
model_dics=model.attribute_dictionaries

#only if "skelion_dict doesnt exist we create it
if model_dics["skelion_dict"]==nil then
model.set_attribute("skelion_dict","plugin_version","0")
end
#dictionary always different of nil:
skelion_dict=model_dics["skelion_dict"]

	if model.georeferenced?  && entities[0]!=nil then
			array_ent=entities.collect{|el| el}
			northangle=model_dics["GeoReference"]["GeoReferenceNorthAngle"]
		
		if (skelion_dict["is_rotated"]==nil ||skelion_dict["is_rotated"]=="False") && northcase==0 then
#case 0 north=+Y, case1 north=georeference			
				#rotation
				t0=Geom::Transformation.new(Geom::Point3d.new(0,0,0), Geom::Vector3d.new(0,0,1), northangle.degrees)
				entities.transform_entities(t0,array_ent)
				#dictionary key "is_rotated"
				v1=model.set_attribute("skelion_dict","is_rotated","True")
				#shadow engine correction:
				shadow=model.shadow_info
				shadow["NorthAngle"]=0
#case1 north=georeference	
		elsif skelion_dict["is_rotated"]=="True" && northcase==1
				#rotation
				t1=Geom::Transformation.new(Geom::Point3d.new(0,0,0), Geom::Vector3d.new(0,0,1), -1*northangle.degrees)
				entities.transform_entities(t1,array_ent)
				#dictionary key "is_rotated"
				v1=model.set_attribute("skelion_dict","is_rotated","False")
				#shadow engine correction:
				shadow=model.shadow_info
				shadow["NorthAngle"]=northangle
					
		else
			if skelion_dict["is_rotated"]=="True"
				UI.messagebox("Model is rotated. Y+==TrueNorth")
			elsif skelion_dict["is_rotated"]=="False" 
				UI.messagebox("Model is not rotated. Y+!=TrueNorth. Ready to export in GoogleEarth")
			elsif skelion_dict["is_rotated"]==nil
				UI.messagebox("Model is not rotated. Y+!=TrueNorth. Ready to export in GoogleEarth")
			end
		end
	else
	UI.messagebox("The model is not GeoReferenced or there aren't entities to rotate")
	end
	
end

#toolbar:

model = Sketchup.active_model
path1 = Sketchup.find_support_file("n_16.png", "Plugins/north_correction")
path2 = Sketchup.find_support_file("n_24.png", "Plugins/north_correction")
path3 = Sketchup.find_support_file("in_16.png", "Plugins/north_correction")
path4 = Sketchup.find_support_file("in_24.png", "Plugins/north_correction")

toolbar = UI::Toolbar.new "rot_north"
 
 
     # First button
     cmd = UI::Command.new("rotate_north") {
	 northrotationbug(0)}
	 cmd.small_icon = path1
     cmd.large_icon = path2
     cmd.tooltip = "Press to rotate all entities to set north to 0"
     cmd.status_bar_text = "North correction"
     cmd.menu_text = "North correction"
	 
     toolbar = toolbar.add_item cmd

	 
	 # Second button
     cmd = UI::Command.new("restore_north") {
	 northrotationbug(1)}
	 cmd.small_icon = path3
     cmd.large_icon = path4
     cmd.tooltip = "Press to restore north and model"
     cmd.status_bar_text = "Restore North"
     cmd.menu_text = "Restore North"
	 
     toolbar = toolbar.add_item cmd
	 
	 
	 toolbar.show





